{% extends 'appPrueba/plantilla.html' %}

{% block content %}

<div class="col-md-6 offset-3">
	<h3 style="text-align: center; margin-bottom: 3%;">Sube tu foto</h3>
	<form class="form1" action="" method="post" enctype="multipart/form-data" id="form">
		{% csrf_token %}
		<label>Nickname:</label>
		<input class="form-control" type="text" name="nickname" required>
		<label>Nombre de mascota:</label>
		<input class="form-control" type="text" name="nombre" required>
		<label>Foto:</label>
		<input type="file" name="foto" id="imgInp" accept="image/*" required>
		<div class="myImg">
		</div>
		<button type="submit" class="form-control btn btn-primary" id="guardar"><i class="fas fa-save"></i> Guardar</button>
	</form>
</div>

{% include 'appPrueba/modalGuardando.html' %}

{% endblock content %}

{% block extrajs %}

<script type="text/javascript" src="http://cdn.sobekrepository.org/includes/jquery-rotate/2.2/jquery-rotate.min.js"></script>

<script>
var angle = 0;
var width = 0;
var height = 0;
var aux = false;

$(document).ready(function(){
	$('#guardar').on('click', function(){
		var valido = true;
		$(":required").each(function() {
		   if($(this).val() === "") valido = false;
		});
		if(valido){
			$('#guardando').modal();
		}
    });

	function readURL(input) {
		$('.myImg').empty();
		angle = 0;
		transform = false;
		if (input.files && input.files[0]) {
			var reader = new FileReader();
			reader.onload = function (e) {
				$('.myImg').append('<button type="button" id="rotate" class="btn btn-primary"><i class="fas fa-sync"></i> Rotar</button> <button type="button" id="btnFlipX" class="btn btn-primary">Flip Horizontal</button> <button type="button" id="btnFlipY" class="btn btn-primary">Flip Vertical</button>');
				$('.myImg').append('<div name="imgContainer"><img alt="your image" width="100%"></div>');
				$('.myImg').append('<input type="number" id="angle" name="angle" value="0" hidden>');
				$('.myImg').append('<input type="number" id="flipX" name="flip" value="0" hidden>');
				width = 0;
				height = 0;
				aux = false;
				$('#rotate').click(function() {
					initSizes();
					rotar((angle + 90) % 360)
				});

				$('#btnFlipX').click(function() {
					flipH();
				});

				$('#btnFlipY').click(function() {
					initSizes();
					rotar((angle + 90) % 360);
					rotar((angle + 90) % 360);
					flipH();
				});

				$('img').attr('src', e.target.result);
			}

			reader.readAsDataURL(input.files[0]);
		}
	}

	function rotar(newAngle){
		$('[name="imgContainer"]').removeClass("rotate" + angle);
		angle = newAngle;
		if(angle > 0){
			$('[name="imgContainer"]').addClass("rotate" + angle);
		}
		$('#angle').val(angle);
		if($('[name="imgContainer"]').css('width') == $('[name="imgContainer"]').css('height')){
			$('[name="imgContainer"]').css({'width': width.toString()+'px', 'height': height.toString()+'px'})
		}else{
			height = width * width/height;
			$('[name="imgContainer"]').css({'width': width.toString()+'px', 'height': height.toString()+'px'})
			if(aux){
				if(width > height){
					$('img').css({'width': width.toString()+'px', 'height': height.toString()+'px'})
				}else{
					$('img').css({'width': height.toString()+'px', 'height': width.toString()+'px'})
				}
			}else{
				if(width < height){
					$('img').css({'width': width.toString()+'px', 'height': height.toString()+'px'})
				}else{
					$('img').css({'width': height.toString()+'px', 'height': width.toString()+'px'})
				}
			}
		}
	}

	function flipH(){
		if(!$('[name="imgContainer"]').hasClass('flipX')){
			$('[name="imgContainer"]').addClass('flipX');
			$('#flipX').val(1);
		}else{
			$('[name="imgContainer"]').removeClass('flipX');
			$('#flipX').val(0);
		}
	}

	function initSizes(){
		if(width == 0 && height == 0){
			width = parseFloat($('img').css('width').replace('px',''));
			height = parseFloat($('img').css('height').replace('px',''));
			if(width > height) aux = true;
		}
	}

	$("#imgInp").change(function(){
		readURL(this);
	});
});

</script>

{% endblock extrajs %}
